#include "raylib.h"
#include "rlImGui.h"
#include "panel.h"
#include "imgui.h"

int main() {
    const int screenWidth = 1920;
    const int screenHeight = 1080;

    // Initialize Raylib
    InitWindow(screenWidth, screenHeight, "DMX Raylib UI");
    SetTargetFPS(60);

    // Initialize rlImGui
    rlImGuiSetup(true);  // Use true for dark theme, false for light theme

    // Create the timeline and properties panels
    Panel timelinePanel = {{0, 0, screenWidth * 0.75f, screenHeight * 0.6f}, "Timeline", LIGHTGRAY, DARKGRAY, true};
    Panel propertiesPanel = {{screenWidth * 0.75f, 0, screenWidth * 0.25f, screenHeight}, "Properties", LIGHTGRAY, DARKGRAY, true};

    while (!WindowShouldClose()) {
        // Update panels
        timelinePanel.Update();
        propertiesPanel.Update();

        BeginDrawing();
        ClearBackground(RAYWHITE);

        // Start ImGui frame
        rlImGuiBegin();

        // Create a simple ImGui window (you can expand this with more GUI elements)
        ImGui::Begin("ImGui Panel");
        ImGui::Text("Hello, world!");
        // ImGui::SliderFloat("Slider", &timelinePanel.position.x, 0.0f, (float)screenWidth);
        ImGui::End();

        // End ImGui frame
        rlImGuiEnd();

        // Draw Raylib panels
        if (timelinePanel.isVisible) timelinePanel.Draw();
        if (propertiesPanel.isVisible) propertiesPanel.Draw();

        DrawFPS(3, screenHeight - 20);
        EndDrawing();
    }

    // Shutdown rlImGui
    rlImGuiShutdown();

    CloseWindow();
    return 0;
}
